{
  open Parser
  exception Eof
}

let var_id   = ['a'-'z' 'A'-'Z' '0'-'9']+
let space    = [' ' '\t']+
let newline  = '\r' | '\n' | "\r\n"

rule read = parse
	| var_id   { VAR (Lexing.lexeme lexbuf) }
	| '('      { LEFT_PAR }
	| ')'      { RIGHT_PAR }
	| '.'      { DOT }
    | '\\'     { LAMBDA }
	| space    { read lexbuf }
	| newline  { read lexbuf }
	| eof      { exit 0 }